<?
header('Content-Type: text/html; charset=utf-8');
require_once('../Config.php');
require_once('../Lib/SQL.php');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>GPS Mapping Login/Register</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head>
<body>
<?
$Error=ProcessAction();
function ProcessAction() //Returns either the user data, or a message on error
{
	//Confirm required variables for login/update
	global $ShowUserInfo;
	$Variables=Array('UserName'=>'/^[-A-Za-z0-9_ \\.]{1,25}$/D', 'Password'=>'/./', 'Action'=>'/^(?:Register|Login)$/D');
	$VarErrors=Array('UserName'=>'Username can be 1-25 characters and contain letters, numbers, spaces, underscores, periods, and dashes', 'Password'=>'You must supply a password', 'Action'=>'You must specify a valid action');
	foreach($Variables as $VarName => $VarPreg)
		if(!isset($_REQUEST[$VarName]))
			return ''; //If a required variable is not set, just pretend nothing was passed at all (just display the form)
		else if(!preg_match($VarPreg, $_REQUEST[$VarName]))
			return $VarErrors[$VarName];
		else
			${$VarName}=$_REQUEST[$VarName];

	//Confirm information
	$UserInfo=MysqlFetchData(MysqlQuery('SELECT UserID, AccessKey, Password FROM Users WHERE UserName=?', $UserName), 0);
	if(($Action=='Register') == ($UserInfo!==FALSE)) //If registering and username already exists, or loggining in/updating and username does not exist
		return $Action=='Register' ? 'Username is already registered' : 'Username is invalid';

	//Register the user
	if($Action=='Register')
	{
		//Create a uniquea ccess key
		$AccessKeySymbols='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
		do
		{
			$AccessKey='';
			for($i=0;$i<6;$i++)
				$AccessKey.=substr($AccessKeySymbols, rand(0,strlen($AccessKeySymbols)-1), 1);
		}
		while(MysqlFetchData(MysqlQuery('SELECT UserID FROM Users WHERE AccessKey=?', $AccessKey), 0)!==FALSE);

		//Create the user
		global $SQLInfo;
		if(MysqlQuery('INSERT INTO Users (UserName, Password, AccessKey) VALUES (?,?,?)', $UserName, strtoupper(sha1("$UserName!$Password")), $AccessKey)->affected_rows!=1)
			return 'Error creating user, please try again';
		$ShowUserInfo=Array('UserID'=>mysqli_insert_id($SQLInfo['Reference']), 'AccessKey'=>$AccessKey);
		$_REQUEST['Action']='Login'; //Change the selected action for the user
		return 'Username registered';
	}

	//Update the user's password
	if(strtoupper(sha1("$UserName!$Password"))!=$UserInfo['Password'])
		return 'Password does not match';
	$ShowUserInfo=$UserInfo;
	if(isset($_REQUEST['NewPassword']) && $_REQUEST['NewPassword']!='')
	{
		if(!isset($_REQUEST['ConfirmNewPassword']) || $_REQUEST['ConfirmNewPassword']!=$_REQUEST['NewPassword'])
			return 'New passwords do not match';
		if(MysqlQuery('Update Users SET Password=? WHERE UserName=?', strtoupper(sha1("$UserName!$_REQUEST[NewPassword]")), $UserName)->affected_rows!=1)
			return 'Error updating password, or password did not change, please try again';
		return 'Password changed';
	}

	return '';
}
?>
<form action="Login.php" method=post>
<div style="color:red"><?=$Error?></div>
	Register/Update/Login:
	<table>
		<tr><td>Action:</td><td>
<?=GetRadioValue('Action', Array('Register'=>'Register', 'Login'=>'Login/Update'))?>
		</td></tr>
		<tr><td>User Name:</td><td><?=GetTextValue('UserName', is_array($ShowUserInfo))?></td></tr>
		<tr><td>Password:</td><td><input type=password name=Password></td></tr>
		<? if(is_array($ShowUserInfo)) { ?>
		<tr><td>New Password:</td><td><input type=password name=NewPassword></td></tr>
		<tr><td>Confirm New Password:</td><td><input type=password name=ConfirmNewPassword></td></tr>
		<tr><td>User ID</td><td><?=$ShowUserInfo['UserID']?></td></tr>
		<tr><td>Access Key</td><td><?=$ShowUserInfo['AccessKey']?></td></tr>
		<? } ?>
	</table>
	<input type=submit value="Submit">
</form><br>
<a href="index.php">Back to mapping display</a>
</body>
</html>
<?
function GetTextValue($Name, $Disable)
{
	return "<input type=text name='$Name' ".($Disable ? 'readonly style="background-color:lightgrey" ' : '').'value="'.(isset($_REQUEST[$Name]) ? EHTML($_REQUEST[$Name]) : '').'">';
}
function GetRadioValue($Name, $Values)
{
	$Output=Array();
	$Value=(isset($_REQUEST[$Name]) && isset($Values[$_REQUEST[$Name]]) ? $_REQUEST[$Name] : key($Values));
	foreach($Values as $Var => $DisplayName)
		$Output[]="<label><input type=radio name='$Name' ".($Value==$Var ? 'checked ' : '')."value='".EHTML($Var)."'>".EHTML($DisplayName)."</label>";
	return implode("\n", $Output);
}
?>